package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.config.ConfigKey;
import net.knarcraft.blockhunt.manager.Command;
import net.knarcraft.blockhunt.manager.PermissionsManager;
import net.knarcraft.blockhunt.util.MessageHelper;
import org.bukkit.entity.Player;

public class HelpCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, String[] args) {
        int amountCommands = 0;
        for (Command command : MemoryStorage.commands) {
            if (command.usage() != null) {
                amountCommands = amountCommands + 1;
            }
        }

        int maxPages = (int) Math.round(amountCommands / 3.0);
        if (maxPages <= 0) {
            maxPages = 1;
        }

        int page = 1;
        if (args.length == 1) {
            MessageHelper.sendMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-" + BlockHunt.getPluginDescriptionFile().getName() + " %Nhelp page %A" + page + "%N/%A" + maxPages);
            int i = 1;
            for (Command command : MemoryStorage.commands) {
                if (i <= 4) {
                    if (command.usage() != null) {
                        if (PermissionsManager.hasPermission(player, command.permission(), false)) {
                            MessageHelper.sendMessage(player, "%A" + command.usage() + "%N - " + MemoryStorage.messages.getFileConfiguration().get(command.help().getPath()));
                        } else {
                            MessageHelper.sendMessage(player, "%MemoryStorage" + command.usage() + "%N - " + MemoryStorage.messages.getFileConfiguration().get(command.help().getPath()));
                        }
                        i = i + 1;
                    }
                }
            }

        } else {
            try {
                page = Integer.parseInt(args[1]);
            } catch (NumberFormatException ignored) {
            }

            if (maxPages < page) {
                maxPages = page;
            }

            MessageHelper.sendMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-" + BlockHunt.getPluginDescriptionFile().getName() + " %Nhelp page %A" + page + "%N/%A" + maxPages);

            int i = 1;
            for (Command command : MemoryStorage.commands) {
                if (i <= (page * 4) + 4) {
                    if (command.usage() != null) {
                        if (i >= ((page - 1) * 4) + 1 && i <= ((page - 1) * 4) + 4) {
                            if (PermissionsManager.hasPermission(player, command.permission(), false)) {
                                MessageHelper.sendMessage(player, "%A" + command.usage() + "%N - " + MemoryStorage.messages.getFileConfiguration().get(command.help().getPath()));
                            } else {
                                MessageHelper.sendMessage(player, "%MemoryStorage" + command.usage() + "%N - " + MemoryStorage.messages.getFileConfiguration().get(command.help().getPath()));
                            }
                        }
                        i = i + 1;
                    }
                }
            }
        }
        MessageHelper.sendMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-&oHelp Page");
        return true;
    }
}
