package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.BlockHunt;
import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.config.ConfigKey;
import net.knarcraft.blockhunt.util.MessageHelper;
import org.bukkit.entity.Player;

public class ListCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, String[] args) {
        MessageHelper.sendMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-" + BlockHunt.getPluginDescriptionFile().getName());
        if (MemoryStorage.arenaMap.size() >= 1) {
            MessageHelper.sendMessage(player, "&7Available arena(s):");
            for (Arena arena : MemoryStorage.arenaMap.values()) {
                MessageHelper.sendMessage(player, "%A" + arena.arenaName);
            }
        } else {
            MessageHelper.sendMessage(player, "&7&oNo arenas available...");
            MessageHelper.sendMessage(player, "&7&oCreate an arena first please.");
        }
        MessageHelper.sendMessage(player, ConfigKey.CHAT_HEADER_HIGH, "header-&oArenas list");
        return true;
    }
}
