package net.knarcraft.blockhunt.command;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.manager.CommandManager;
import net.knarcraft.blockhunt.util.MessageHelper;
import org.bukkit.Effect;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;

public class RemoveCommand extends DefaultCommand {

    @Override
    public boolean execute(Player player, String[] args) {
        if (player != null) {
            if (args.length <= 1) {
                MessageHelper.sendMessage(player, MessageKey.ERROR_NOT_ENOUGH_ARGUMENTS, "syntax-" +
                        CommandManager.getRemoveCommand().usage());
            } else {
                Arena arena = MemoryStorage.arenaMap.get(args[1].toLowerCase());
                if (arena != null) {
                    MessageHelper.sendMessage(player, MessageKey.NORMAL_REMOVE_REMOVED_ARENA, "name-" + args[1]);
                    MemoryStorage.arenas.getFileConfiguration().set(args[1], null);
                    for (String sign : MemoryStorage.signs.getFileConfiguration().getKeys(false)) {
                        if (MemoryStorage.signs.getFileConfiguration().get(sign + ".arenaName").toString().equalsIgnoreCase(args[1])) {
                            Location signLoc = (Location) MemoryStorage.signs.getFileConfiguration().get(sign + ".location");
                            signLoc.getBlock().setType(Material.AIR);
                            signLoc.getWorld().playEffect(signLoc, Effect.MOBSPAWNER_FLAMES, 0);
                            signLoc.getWorld().playSound(signLoc, Sound.ENTITY_ENDER_DRAGON_FLAP, 1, 1);
                            MemoryStorage.signs.getFileConfiguration().set(sign, null);
                        }
                    }

                    MemoryStorage.arenas.save();
                    MemoryStorage.signs.load();

                    MemoryStorage.arenaMap.remove(arena.arenaName.toLowerCase());
                    return true;
                }

                MessageHelper.sendMessage(player, MessageKey.ERROR_NO_ARENA, "name-" + args[1]);
            }
        } else {
            MessageHelper.sendMessage(null, MessageKey.ERROR_ONLY_IN_GAME);
        }
        return true;
    }
}
