package net.knarcraft.blockhunt.listener;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.arena.Arena;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageEvent;

public class OnEntityDamageEvent implements Listener {

    @EventHandler(priority = EventPriority.NORMAL, ignoreCancelled = true)
    public void onEntityDamageEvent(EntityDamageEvent event) {
        if (!(event.getEntity() instanceof Player player)) {
            return;
        }

        Arena arena = MemoryStorage.playerArena.get(player);
        if (arena == null) {
            return;
        }

        switch (event.getCause()) {
            case ENTITY_ATTACK:
            case PROJECTILE:
                // Do nothing about damage from an entity
                // Any entity damage that makes it to here was already allowed by the EntityDamageByEntity event
                break;
            case FALL:
                // Prevent seeker/hider fall damage (if configured)
                if ((arena.seekers.contains(player) && !arena.seekersTakeFallDamage) ||
                        (arena.hiders.contains(player) && !arena.hidersTakeFallDamage)) {
                    event.setCancelled(true);
                }
                break;
            default:
                // Cancel all non-entity damage for all players (lava, drowning, fire, etc)
                event.setCancelled(true);
                break;
        }
    }

}