package net.knarcraft.blockhunt.listener;

import net.knarcraft.blockhunt.MemoryStorage;
import net.knarcraft.blockhunt.config.MessageKey;
import net.knarcraft.blockhunt.util.MessageHelper;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerTeleportEvent;

public class OnPlayerTeleportEvent implements Listener {

    @EventHandler(priority = EventPriority.HIGHEST, ignoreCancelled = true)
    public void onPlayerTeleportEvent(PlayerTeleportEvent event) {
        Player player = event.getPlayer();
        if (MemoryStorage.playerData.get(player) != null) {
            handlePlayer(event, player);
        }
    }

    /**
     * Handle a player that is in an arena
     *
     * @param event  PlayerTeleportEvent
     * @param player Player
     */
    private void handlePlayer(PlayerTeleportEvent event, Player player) {
        Location storedLoc = MemoryStorage.teleportLocation.remove(player);
        Location to = event.getTo();
        if (storedLoc == null || storedLoc.getWorld() != to.getWorld() || to.distanceSquared(storedLoc) > 1) {
            MessageHelper.sendMessage(player, MessageKey.ERROR_TELEPORT_BLOCKED);
            event.setCancelled(true);
        }
    }
}
